opal/mca/paffinity/paffinity.h File Reference.TH "opal/mca/paffinity/paffinity.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/mca/paffinity/paffinity.h \- paffinity (processor affinity) framework component interface definitions. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mca/base/base.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOPAL_PAFFINITY_BASE_VERSION_1_0_0\fP"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef const struct \fBopal_paffinity_base_module_1_0_0_t\fP *(* \fBopal_paffinity_base_component_query_1_0_0_fn_t\fP )(int *priority)"
.br
.RI "\fIQuery function for paffinity components. \fP"
.ti -1c
.RI "typedef int(* \fBopal_paffinity_base_module_init_1_0_0_fn_t\fP )(void)"
.br
.RI "\fIModule initialization function. \fP"
.ti -1c
.RI "typedef int(* \fBopal_paffinity_base_module_get_num_processors_t\fP )(int *nprocs)"
.br
.RI "\fIModule function to query the physical number of processors (which may be different than what schedulers have allocated to us). \fP"
.ti -1c
.RI "typedef int(* \fBopal_paffinity_base_module_set_fn_t\fP )(int cpuid)"
.br
.RI "\fIModule function to set this process' affinity to a specific [virtual] CPU. \fP"
.ti -1c
.RI "typedef int(* \fBopal_paffinity_base_module_get_fn_t\fP )(int *cpuid)"
.br
.RI "\fIModule function to get this process' affinity to a specific [virtual] CPU. \fP"
.ti -1c
.RI "typedef \fBopal_paffinity_base_component_1_0_0_t\fP \fBopal_paffinity_base_component_1_0_0_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBopal_paffinity_base_module_1_0_0_t\fP \fBopal_paffinity_base_module_1_0_0_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SH "Detailed Description"
.PP 
paffinity (processor affinity) framework component interface definitions. 

Intent
.PP
This is an extremely simple framework that is used to support the OS-specific API for placement of processes on processors. It does *not* decide scheduling issues -- it is simply for assigning the current process it to a specific processor. As such, the components are likely to be extremely short/simple -- there will likely be one component for each OS/API that we support (e.g., Linux, IRIX, etc.). As a direct consequence, there will likely only be one component that is useable on a given platform (making selection easy).
.PP
It is *not* an error if there is no paffinity component available; processor affinity services are simply not available. Hence, paffinity component functions are invoked through short wrapper functions in paffinity/base (that check to see if there is a selected component before invoking function pointers). If there is no selected component, they return an appropriate error code.
.PP
General scheme
.PP
The component has one function: query(). It simply returns a priority (for the unlikely event where there are multiple components available on a given platform).
.PP
The module has four functions:
.PP
.IP "\(bu" 2
module_init: initialze the module
.IP "\(bu" 2
get_num_processors: return the maximum number N that can be used in the set() module function (i.e., the number of available processors)
.IP "\(bu" 2
set: set this process's affinity to a specific processor
.IP "\(bu" 2
get: get this process's processor affinity
.PP

.SH "Define Documentation"
.PP 
.SS "#define OPAL_PAFFINITY_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* paffinity v1.0 is chained to MCA v1.0 */ \
    MCA_BASE_VERSION_1_0_0, \
    /* paffinity v1.0 */ \
    'paffinity', 1, 0, 0
.fi
.SH "Typedef Documentation"
.PP 
.SS "typedef const struct \fBopal_paffinity_base_module_1_0_0_t\fP*(* \fBopal_paffinity_base_component_query_1_0_0_fn_t\fP)(int *priority)"
.PP
Query function for paffinity components. 
.PP
Simply returns a priority to rank it against other available paffinity components (assumedly, only one component will be available per platform, but it's possible that there could be more than one available). 
.SS "typedef int(* \fBopal_paffinity_base_module_get_fn_t\fP)(int *cpuid)"
.PP
Module function to get this process' affinity to a specific [virtual] CPU. 
.PP
Returns OPAL_ERR_NOT_FOUND if \fBopal_paffinity_base_module_set_fn_t()\fP was not previously invoked in this process. 
.SS "typedef int(* \fBopal_paffinity_base_module_init_1_0_0_fn_t\fP)(void)"
.PP
Module initialization function. 
.PP
Should return OPAL_SUCCESS. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
